io.vertx.core.http

## Interface ClientWebSocket

- All Superinterfaces:
    ReadStream<Buffer>, StreamBase, WebSocket, WebSocketBase, WriteStream<Buffer>

      public interface ClientWebSocket
      extends WebSocket

  Represents a client-side WebSocket initially not connected.
  Author:
    Julien Viet

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `ClientWebSocket` | `binaryMessageHandler(Handler<Buffer> handler)` Set a binary message handler on the connection.
    `ClientWebSocket` | `closeHandler(Handler<Void> handler)` Set a close handler.
    `default Future<WebSocket>` | `connect(int port, String host, String requestURI)` Like `connect(int, String, String, Handler)` but returns a `Future` of the asynchronous result
    `default void` | `connect(int port, String host, String requestURI, Handler<AsyncResult<WebSocket>> handler)` Connect a WebSocket to the specified port, host and relative request URI
    `default Future<WebSocket>` | `connect(String requestURI)` Connect this WebSocket at the relative request URI using the default host and port.
    `default void` | `connect(String requestURI, Handler<AsyncResult<WebSocket>> handler)` Connect this WebSocket at the relative request URI using the default host and port.
    `default Future<WebSocket>` | `connect(String host, String requestURI)` Connect this WebSocket to the host and relative request URI and default port.
    `default void` | `connect(String host, String requestURI, Handler<AsyncResult<WebSocket>> handler)` Connect this WebSocket to the host and relative request URI and default port.
    `Future<WebSocket>` | `connect(WebSocketConnectOptions options)` Like `connect(WebSocketConnectOptions, Handler)` but returns a `Future` of the asynchronous result
    `void` | `connect(WebSocketConnectOptions options, Handler<AsyncResult<WebSocket>> handler)` Connect a WebSocket with the specified options.
    `ClientWebSocket` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `ClientWebSocket` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `ClientWebSocket` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `ClientWebSocket` | `frameHandler(Handler<WebSocketFrame> handler)` Set a frame handler on the connection.
    `ClientWebSocket` | `handler(Handler<Buffer> handler)` Set a data handler.
    `ClientWebSocket` | `pongHandler(Handler<Buffer> handler)` Set a pong frame handler on the connection.
    `ClientWebSocket` | `textMessageHandler(Handler<String> handler)` Set a text message handler on the connection.
    `ClientWebSocket` | `writeBinaryMessage(Buffer data, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.writeBinaryMessage(Buffer)` but with an `handler` called when the operation completes
    `ClientWebSocket` | `writeFinalBinaryFrame(Buffer data, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.writeFinalBinaryFrame(Buffer, Handler)` but with an `handler` called when the operation completes
    `ClientWebSocket` | `writeFinalTextFrame(String text, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.writeFinalTextFrame(String, Handler)` but with an `handler` called when the operation completes
    `ClientWebSocket` | `writeFrame(WebSocketFrame frame, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.writeFrame(WebSocketFrame)` but with an `handler` called when the operation completes
    `ClientWebSocket` | `writePing(Buffer data, Handler<AsyncResult<Void>> handler)` Writes a ping frame to the connection.
    `ClientWebSocket` | `writePong(Buffer data, Handler<AsyncResult<Void>> handler)` Writes a pong frame to the connection.
    `ClientWebSocket` | `writeTextMessage(String text, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.writeTextMessage(String)` but with an `handler` called when the operation completes

    - ### Methods inherited from interface io.vertx.core.http.WebSocket

      `fetch, pause, resume, setWriteQueueMaxSize`

    - ### Methods inherited from interface io.vertx.core.http.WebSocketBase

      `binaryHandlerID, close, close, close, close, close, close, closeReason, closeStatusCode, end, end, headers, isClosed, isSsl, localAddress, peerCertificateChain, peerCertificates, remoteAddress, sslSession, subProtocol, textHandlerID, writeBinaryMessage, writeFinalBinaryFrame, writeFinalTextFrame, writeFrame, writePing, writePong, writeTextMessage`

    - ### Methods inherited from interface io.vertx.core.streams.ReadStream

      `collect, pipe, pipeTo, pipeTo`

    - ### Methods inherited from interface io.vertx.core.streams.WriteStream

      `end, end, write, write, writeQueueFull`

- - ### Method Detail

    - #### connect

          default void connect(int port,
                               String host,
                               String requestURI,
                               Handler<AsyncResult<WebSocket>> handler)

      Connect a WebSocket to the specified port, host and relative request URI
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
        `handler` - handler that will be called with the WebSocket when connected

    - #### connect

          default Future<WebSocket> connect(int port,
                                            String host,
                                            String requestURI)

      Like `connect(int, String, String, Handler)` but returns a `Future` of the asynchronous result

    - #### connect

          void connect(WebSocketConnectOptions options,
                       Handler<AsyncResult<WebSocket>> handler)

      Connect a WebSocket with the specified options.
      Parameters:
        `options` - the request options
        `handler` - handler that will be called with the WebSocket when connected

    - #### connect

          Future<WebSocket> connect(WebSocketConnectOptions options)

      Like `connect(WebSocketConnectOptions, Handler)` but returns a `Future` of the asynchronous result

    - #### connect

          default void connect(String host,
                               String requestURI,
                               Handler<AsyncResult<WebSocket>> handler)

      Connect this WebSocket to the host and relative request URI and default port.
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
        `handler` - handler that will be called with the WebSocket when connected

    - #### connect

          default Future<WebSocket> connect(String host,
                                            String requestURI)

      Connect this WebSocket to the host and relative request URI and default port.
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
      Returns:
        a future notified when the WebSocket when connected

    - #### connect

          default void connect(String requestURI,
                               Handler<AsyncResult<WebSocket>> handler)

      Connect this WebSocket at the relative request URI using the default host and port.
      Parameters:
        `requestURI` - the relative URI
        `handler` - handler that will be called with the WebSocket when connected

    - #### connect

          default Future<WebSocket> connect(String requestURI)

      Connect this WebSocket at the relative request URI using the default host and port.
      Parameters:
        `requestURI` - the relative URI
      Returns:
        a future notified when the WebSocket when connected

    - #### handler

          ClientWebSocket handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Specified by:
        `handler` in interface `WebSocket`
      Specified by:
        `handler` in interface `WebSocketBase`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          ClientWebSocket endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `endHandler` in interface `WebSocket`
      Specified by:
        `endHandler` in interface `WebSocketBase`
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          ClientWebSocket drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WebSocket`
      Specified by:
        `drainHandler` in interface `WebSocketBase`
      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### closeHandler

          ClientWebSocket closeHandler(Handler<Void> handler)

      Description copied from interface: `WebSocketBase`
      Set a close handler. This will be called when the WebSocket is closed.

      After this callback, no more messages are expected. When the WebSocket received a close frame, the `WebSocketBase.closeStatusCode()` will return the status code and `WebSocketBase.closeReason()` will return the reason.
      Specified by:
        `closeHandler` in interface `WebSocket`
      Specified by:
        `closeHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### frameHandler

          ClientWebSocket frameHandler(Handler<WebSocketFrame> handler)

      Description copied from interface: `WebSocketBase`
      Set a frame handler on the connection. This handler will be called when frames are read on the connection.
      Specified by:
        `frameHandler` in interface `WebSocket`
      Specified by:
        `frameHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### textMessageHandler

          ClientWebSocket textMessageHandler(Handler<String> handler)

      Description copied from interface: `WebSocketBase`
      Set a text message handler on the connection. This handler will be called similar to the `WebSocketBase.binaryMessageHandler(Handler)`, but the buffer will be converted to a String first
      Specified by:
        `textMessageHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### binaryMessageHandler

          ClientWebSocket binaryMessageHandler(Handler<Buffer> handler)

      Description copied from interface: `WebSocketBase`
      Set a binary message handler on the connection. This handler serves a similar purpose to `WebSocketBase.handler(Handler)` except that if a message comes into the socket in multiple frames, the data from the frames will be aggregated into a single buffer before calling the handler (using `WebSocketFrame.isFinal()` to find the boundaries).
      Specified by:
        `binaryMessageHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### pongHandler

          ClientWebSocket pongHandler(Handler<Buffer> handler)

      Description copied from interface: `WebSocketBase`
      Set a pong frame handler on the connection. This handler will be invoked every time a pong frame is received on the server, and can be used by both clients and servers since the RFC 6455 section 5.5.2 and section 5.5.3 do not specify whether the client or server sends a ping.

      Pong frames may be at most 125 bytes (octets).

      There is no ping handler since ping frames should immediately be responded to with a pong frame with identical content

      Pong frames may be received unsolicited.

      Specified by:
        `pongHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### exceptionHandler

          ClientWebSocket exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WebSocket`
      Specified by:
        `exceptionHandler` in interface `WebSocketBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeFrame

          ClientWebSocket writeFrame(WebSocketFrame frame,
                                     Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeFrame(WebSocketFrame)` but with an `handler` called when the operation completes
      Specified by:
        `writeFrame` in interface `WebSocket`
      Specified by:
        `writeFrame` in interface `WebSocketBase`

    - #### writeFinalTextFrame

          ClientWebSocket writeFinalTextFrame(String text,
                                              Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeFinalTextFrame(String, Handler)` but with an `handler` called when the operation completes
      Specified by:
        `writeFinalTextFrame` in interface `WebSocket`
      Specified by:
        `writeFinalTextFrame` in interface `WebSocketBase`

    - #### writeFinalBinaryFrame

          ClientWebSocket writeFinalBinaryFrame(Buffer data,
                                                Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeFinalBinaryFrame(Buffer, Handler)` but with an `handler` called when the operation completes
      Specified by:
        `writeFinalBinaryFrame` in interface `WebSocket`
      Specified by:
        `writeFinalBinaryFrame` in interface `WebSocketBase`

    - #### writeBinaryMessage

          ClientWebSocket writeBinaryMessage(Buffer data,
                                             Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeBinaryMessage(Buffer)` but with an `handler` called when the operation completes
      Specified by:
        `writeBinaryMessage` in interface `WebSocket`
      Specified by:
        `writeBinaryMessage` in interface `WebSocketBase`

    - #### writeTextMessage

          ClientWebSocket writeTextMessage(String text,
                                           Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeTextMessage(String)` but with an `handler` called when the operation completes
      Specified by:
        `writeTextMessage` in interface `WebSocket`
      Specified by:
        `writeTextMessage` in interface `WebSocketBase`

    - #### writePing

          ClientWebSocket writePing(Buffer data,
                                    Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Writes a ping frame to the connection. This will be written in a single frame. Ping frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 Section section 5.5.2.

      There is no handler for ping frames because RFC 6455 clearly states that the only response to a ping frame is a pong frame with identical contents.

      Specified by:
        `writePing` in interface `WebSocket`
      Specified by:
        `writePing` in interface `WebSocketBase`
      Parameters:
        `data` - the data to write, may be at most 125 bytes
        `handler` - called when the ping frame has been successfully written
      Returns:
        a reference to this, so the API can be used fluently

    - #### writePong

          ClientWebSocket writePong(Buffer data,
                                    Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Writes a pong frame to the connection. This will be written in a single frame. Pong frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 section 5.5.2.

      There is no need to manually write a pong frame, as the server and client both handle responding to a ping from with a pong from automatically and this is exposed to users. RFC 6455 section 5.5.3 states that pongs may be sent unsolicited in order to implement a one way heartbeat.

      Specified by:
        `writePong` in interface `WebSocket`
      Specified by:
        `writePong` in interface `WebSocketBase`
      Parameters:
        `data` - the data to write, may be at most 125 bytes
        `handler` - called when the pong frame has been successfully written
      Returns:
        a reference to this, so the API can be used fluently

Copyright © 2024 Eclipse. All rights reserved.